import { __awaiter, __generator } from "tslib";
import { useCallback, useEffect, useRef, useState } from 'react';
import { isPromiseLike } from 'retil-support';
export function useOperation(operation, deps) {
    var _this = this;
    // The types don't allow an `undefined` value to be passed in, but it works.
    //@ts-ignore
    // eslint-disable-next-line react-hooks/exhaustive-deps
    var memoizedOperation = useCallback(operation, deps);
    var _a = useState([false]), state = _a[0], setState = _a[1];
    var abortControllerRef = useRef(null);
    useEffect(function () { return function () {
        if (abortControllerRef.current) {
            abortControllerRef.current.abort();
            abortControllerRef.current = null;
        }
    }; }, []);
    var trigger = useCallback(function (data) { return __awaiter(_this, void 0, void 0, function () {
        var abortController, signal, resultPromise, instantProbe_1, probeResult, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (abortControllerRef.current) {
                        abortControllerRef.current.abort();
                    }
                    abortController = new AbortController();
                    signal = abortController.signal;
                    abortControllerRef.current = abortController;
                    resultPromise = memoizedOperation(data, signal);
                    if (!(resultPromise && isPromiseLike(resultPromise))) return [3 /*break*/, 5];
                    instantProbe_1 = Symbol();
                    return [4 /*yield*/, Promise.race([
                            resultPromise,
                            new Promise(function (resolve) {
                                return setTimeout(function () { return resolve(instantProbe_1); });
                            }),
                        ])];
                case 1:
                    probeResult = _a.sent();
                    if (!(probeResult !== instantProbe_1)) return [3 /*break*/, 2];
                    // If the result promise resolves before a newly created promise, then
                    // let's skip the pending state and immediately set the result on state.
                    if (abortControllerRef.current === abortController) {
                        setState([false, probeResult]);
                    }
                    return [2 /*return*/, probeResult];
                case 2:
                    if (abortControllerRef.current === abortController) {
                        setState([true]);
                    }
                    return [4 /*yield*/, resultPromise];
                case 3:
                    result = _a.sent();
                    if (abortControllerRef.current === abortController) {
                        abortControllerRef.current = null;
                        setState([false, result]);
                    }
                    return [2 /*return*/, result];
                case 4: return [3 /*break*/, 6];
                case 5:
                    setState([false, resultPromise]);
                    return [2 /*return*/, resultPromise];
                case 6: return [2 /*return*/];
            }
        });
    }); }, [memoizedOperation]);
    return [trigger].concat(state);
}
